https://app.swaggerhub.com/apis/testAC/Chopour_KhalaGame_Vdraft0.1/0.010
http://{{localhost:8080}}/v3/api-docs/khala-public
http://{{localhost:8080}}/actuator/health



Khala Game  Rest BE for Bol's challenge
0. GameService-initialize()->BoardState-applyMoves()->Moves-convertMove2cellpieces()->Row-includes->Cells||treasureCell

1. 1.Game Service Initializes a game include of players, Board. //Extensible Service JoinPlayer etc. 2.Board State
   Service // status service of Khala Game Board, includes game move and rules  "Core Logic"
   MoveRequest is the general format of Khala Game, including Cells, treasureCell(treasure)
2. 2 number of players
3. Each player has his own Row of Cells including 6cells for " shared in game"  and +1 treasureCell to collect pieces.
   ...
4. The game will be initialized Each cell has number of (6) pieces in it, except Zero Cells.
5. Zero Cell is the name of a Cell that initialized as 0 pieces. throws exception illegal cellIndexMove
6. Player can choose to move from his row except Zero Cell. MoveIndexCell should include a piece. Throws Exception
7. Turn Passing between players, The cells should be filled by pieces of other player row. OpenApi 3.0 Specifications

MongoDB Embedded- -Board Games have less functional requirements in persisstance layer to use relational database.
-Mostly storing and searching an object is the main goal, MongoDB is generaly known for this capabilities in high
performance.

-Spring Boot 2.5.5 (2.6 later having issues with MongoDB Embedded)

-MakeFile

-To-Do's 1.Cloud enablement with native DB(MongoDB / DynamoDB) orchestrator and Ci/Cd should be improved with static
testing. 2.CQRS pattern for GameService, BoardService Query and Commands can be configured for high Availibility.
3.Dockerization 4.UI according to OpenApi v3 specified definition document

5. Game-User correlation, roles based auhorization


